﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace cosc427_design.ServerRequests
{
    class CalibrationDataUploadRequest : Request
    {
        public CalibrationDataUploadRequest(HttpPOSTRequestSender sender) : base(sender) { }

        public override void ConfirmOutcome()
        {
            Request confirmationReq = new Request(this.Sender);
            confirmationReq.AddParameter("SerialNum", this.Data["SerialNum"]);
            confirmationReq.AddParameter("Username", this.Data["Username"]);
            confirmationReq.AddParameter("Password", this.Data["Password"]);
            confirmationReq.AddParameter("confirmation_id", GetConfirmationIdFromResponse().ToString());
            confirmationReq.Execute();
        }

        private int GetConfirmationIdFromResponse()
        {
            int confirmationId = -1;
            string responseXml = this.GetResponse();
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.LoadXml(responseXml);

            // Read in the response code and check it is as expected
            XmlNode confirmationElement = xmlDoc.GetElementsByTagName("ConfirmationId").Item(0);
            try
            {
                confirmationId = int.Parse(confirmationElement.FirstChild.Value);
            }
            catch (Exception) { }

            return confirmationId;
        }
    }
}
