﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.Specialized;

namespace cosc427_design.ServerRequests
{
    public abstract class HttpPOSTRequestSender
    {
        /// <summary>
        /// Sends the request described by the supplied parameter.
        /// </summary>
        /// <param name="requestData">Dictionary name/value pairs for HTTP POST parameters.</param>
        /// <returns></returns>
        public abstract bool Send(NameValueCollection requestData);

        /// <summary>
        /// Receives the content intended as a response to a sent request.
        /// </summary>
        /// <returns>A byte array containing the request response.</returns>
        public abstract byte[] ReceiveResponse();
    }
}
